obackup/obackup-batch.sh

195 lines
5.3 KiB
Bash
Raw Normal View History

2015-04-24 21:19:30 +02:00
#!/usr/bin/env bash
2015-11-12 01:26:38 +01:00
SUBPROGRAM=obackup
PROGRAM="$SUBPROGRAM-batch" # Batch program to run osync / obackup instances sequentially and rerun failed ones
2016-03-14 21:50:40 +01:00
AUTHOR="(L) 2013-2016 by Orsiris de Jong"
2015-11-12 01:26:38 +01:00
CONTACT="http://www.netpower.fr - ozy@netpower.fr"
2016-08-18 11:53:18 +02:00
PROGRAM_BUILD=2016081704
2015-04-24 21:19:30 +02:00
2015-11-12 01:26:38 +01:00
## Runs an osync /obackup instance for every conf file found
2015-04-24 21:19:30 +02:00
## If an instance fails, run it again if time permits
2016-08-18 11:53:18 +02:00
if ! type "$BASH" > /dev/null; then
echo "Please run this script only with bash shell. Tested on bash >= 3.2"
exit 127
fi
2015-11-12 01:26:38 +01:00
## Configuration file path. The path where all the osync / obackup conf files are, usually /etc/osync or /etc/obackup
CONF_FILE_PATH=/etc/$SUBPROGRAM
2015-04-24 21:19:30 +02:00
## If maximum execution time is not reached, failed instances will be rerun. Max exec time is in seconds. Example is set to 10 hours.
MAX_EXECUTION_TIME=36000
2016-08-17 10:01:55 +02:00
## Specifies the number of total runs an instance may get
MAX_RUNS=3
2015-04-24 21:19:30 +02:00
## Log file path
2015-11-12 01:26:38 +01:00
if [ -w /var/log ]; then
LOG_FILE=/var/log/$SUBPROGRAM-batch.log
2015-04-24 21:19:30 +02:00
else
2015-11-12 01:26:38 +01:00
LOG_FILE=./$SUBPROGRAM-batch.log
2015-04-24 21:19:30 +02:00
fi
# No need to edit under this line ##############################################################
2015-11-12 01:26:38 +01:00
function _logger {
local value="${1}" # What to log
echo -e "$value" >> "$LOG_FILE"
2015-04-24 21:19:30 +02:00
}
2015-11-12 01:26:38 +01:00
function Logger {
local value="${1}" # What to log
local level="${2}" # Log level: DEBUG, NOTICE, WARN, ERROR, CRITIAL
prefix="$(date) - "
if [ "$level" == "CRITICAL" ]; then
_logger "$prefix\e[41m$value\e[0m"
elif [ "$level" == "ERROR" ]; then
_logger "$prefix\e[91m$value\e[0m"
elif [ "$level" == "WARN" ]; then
_logger "$prefix\e[93m$value\e[0m"
elif [ "$level" == "NOTICE" ]; then
_logger "$prefix$value"
elif [ "$level" == "DEBUG" ]; then
if [ "$DEBUG" == "yes" ]; then
_logger "$prefix$value"
fi
else
_logger "\e[41mLogger function called without proper loglevel.\e[0m"
_logger "$prefix$value"
fi
}
function CheckEnvironment {
## osync / obackup executable full path can be set here if it cannot be found on the system
if ! type $SUBPROGRAM.sh > /dev/null 2>&1
2015-11-12 01:26:38 +01:00
then
if [ -f /usr/local/bin/$SUBPROGRAM.sh ]
then
SUBPROGRAM_EXECUTABLE=/usr/local/bin/$SUBPROGRAM.sh
else
Logger "Could not find $SUBPROGRAM.sh" "CRITICAL"
exit 1
fi
else
SUBPROGRAM_EXECUTABLE=$(type -p $SUBPROGRAM.sh)
fi
}
2015-04-24 21:19:30 +02:00
2015-11-12 01:26:38 +01:00
function Batch {
2016-08-17 10:01:55 +02:00
local runs=0 # Number of batch runs
local runList # Actual conf file list to run
local runAgainList # List of failed conf files sto run again
local confFile
local result
2016-08-17 10:24:38 +02:00
## Check for CONF_FILE_PATH
if [ -d "$CONF_FILE_PATH" ]; then
## Get list of .conf files
for confFile in $CONF_FILE_PATH/*.conf
do
2016-08-17 10:44:28 +02:00
if [ -f "$confFile" ]; then
if [ "$runList" == "" ]; then
runList="$confFile"
else
runList=$runList" $confFile"
fi
2016-08-17 10:24:38 +02:00
fi
done
2016-08-17 10:44:28 +02:00
elif [ -f "$CONF_FILE_PATH" ] && [ "${CONF_FILE_PATH##*.}" == "conf" ]; then
2016-08-17 10:24:38 +02:00
runList="$CONF_FILE_PATH"
2016-08-17 10:44:28 +02:00
fi
if [ "$runList" == "" ]; then
2016-08-17 10:24:38 +02:00
Logger "Cannot find conf file path [$CONF_FILE_PATH]." "CRITICAL"
Usage
fi
2015-04-24 21:19:30 +02:00
2016-08-17 10:01:55 +02:00
while ([ $MAX_EXECUTION_TIME -gt $SECONDS ] || [ $MAX_EXECUTION_TIME -eq 0 ]) && [ "$runList" != "" ] && [ $MAX_RUNS -gt $runs ]
2015-04-24 21:19:30 +02:00
do
2016-08-17 10:01:55 +02:00
Logger "$SUBPROGRAM instances will be run for: $runList" "NOTICE"
for confFile in $runList
2015-04-24 21:19:30 +02:00
do
2016-08-17 10:01:55 +02:00
$SUBPROGRAM_EXECUTABLE "$confFile" $opts &
2015-11-12 01:26:38 +01:00
wait $!
2016-08-17 10:01:55 +02:00
result=$?
if [ $result != 0 ]; then
2016-08-18 11:53:18 +02:00
if [ $result == 1 ] || [ $result == 128 ]; then # Do not handle exit code 127 because it is already handled here
2016-08-17 10:01:55 +02:00
Logger "Run instance $(basename $confFile) failed with exit code [$result]." "ERROR"
if [ "$runAgainList" == "" ]; then
runAgainList="$confFile"
else
runAgainList=$runAgainList" $confFile"
fi
elif [ $result == 2 ]; then
Logger "Run instance $(basename $confFile) finished with warnings." "WARN"
2015-04-24 21:19:30 +02:00
fi
else
2016-08-17 10:01:55 +02:00
Logger "Run instance $(basename $confFile) succeed." "NOTICE"
2015-04-24 21:19:30 +02:00
fi
done
2016-08-17 10:01:55 +02:00
runList="$runAgainList"
runAgainList=""
runs=$(($runs + 1))
2015-04-24 21:19:30 +02:00
done
}
2015-11-12 01:26:38 +01:00
function Usage {
echo "$PROGRAM $PROGRAM_BUILD"
echo $AUTHOR
echo $CONTACT
echo ""
echo "Batch script to sequentially run osync or obackup instances and rerun failed ones."
echo "Usage: $SUBPROGRAM-batch.sh [OPTIONS]"
echo ""
echo "[OPTIONS]"
echo "--path=/path/to/conf Path to osync / obackup conf files, defaults to /etc/osync or /etc/obackup"
2016-08-17 10:24:38 +02:00
echo "--max-runs=X Number of max runs per instance, (defaults to 3)"
echo "--max-exec-time=X Retry failed instances only if max execution time not reached (defaults to 36000 seconds). Set to 0 to bypass execution time check"
2015-11-12 01:26:38 +01:00
echo "--no-maxtime Run osync / obackup without honoring conf file defined timeouts"
echo "--dry Will run osync / obackup without actually doing anything; just testing"
echo "--silent Will run osync / obackup without any output to stdout, used for cron jobs"
echo "--verbose Increases output"
exit 128
2015-04-24 21:19:30 +02:00
}
opts=""
for i in "$@"
do
2015-11-12 01:26:38 +01:00
case $i in
--silent)
2015-04-24 21:19:30 +02:00
opts=$opts" --silent"
2015-11-12 01:26:38 +01:00
;;
--dry)
2015-04-24 21:19:30 +02:00
opts=$opts" --dry"
2015-11-12 01:26:38 +01:00
;;
--verbose)
opts=$opts" --verbose"
2015-04-24 21:19:30 +02:00
;;
2015-08-25 15:41:00 +02:00
--no-maxtime)
opts=$opts" --no-maxtime"
;;
2015-04-24 21:19:30 +02:00
--path=*)
CONF_FILE_PATH=${i##*=}
;;
2016-08-17 10:24:38 +02:00
--max-runs=*)
MAX_RUNS=${i##*=}
2015-04-24 21:19:30 +02:00
;;
--max-exec-time=*)
MAX_EXECUTION_TIME=${i##*=}
;;
2015-08-25 15:41:00 +02:00
--help|-h|-?)
2015-04-24 21:19:30 +02:00
Usage
;;
*)
2015-11-12 01:26:38 +01:00
Logger "Unknown param '$i'" "CRITICAL"
2015-04-24 21:19:30 +02:00
Usage
;;
esac
done
CheckEnvironment
2015-11-12 01:26:38 +01:00
Logger "$(date) $SUBPROGRAM batch run" "NOTICE"
2015-04-24 21:19:30 +02:00
Batch